# Dirac - A Video Codec

Created by the British Broadcasting Corporation.

Public Member Functions | Private Member Functions | Private Attributes
dirac::EncPicture Class Reference

`#include <enc_picture.h>`

Inheritance diagram for dirac::EncPicture:

List of all members.

## Public Member Functions
| EncPicture (const PictureParams &pp)
virtual | ~EncPicture ()
void | InitMEData (const PicturePredParams &predparams, const int num_refs)
| Initialise the motion estimation data arrays.
MEData & | GetMEData ()
| Returns the motion data.
const MEData & | GetMEData () const
| Returns the motion data.
void | DropRef (int rindex)
| Drops a reference from the motion vector data.
const PicArray & | OrigData (CompSort c) const
| Returns a given component of the original data.
const PicArray & | UpOrigData (CompSort cs) const
| Returns a given upconverted component of the original data.
void | SetOrigData ()
| Initialises a copy of the data arrays into the original data.
const PicArray & | DataForME (bool combined_me) const
| Returns a version of the picture data suitable for motion estimation.
const PicArray & | UpDataForME (bool combined_me) const
| Returns a version of the picture data suitable for subpel motion estimation.
void | UpdateStatus (const unsigned int mask)
void | FlipStatus (const unsigned int mask)
void | SetStatus (const int status)
unsigned int | GetStatus () const
double | GetComplexity () const
void | SetComplexity (double c)
double | GetNormComplexity () const
void | SetNormComplexity (double c)
double | GetPredBias () const
void | SetPredBias (double b)
Public Member Functions inherited from dirac::Picture
| Picture (const PictureParams &pp)
| Constructor.
| Picture (const Picture &cpy)
| Copy constructor. Private as not currently used [may want to implement reference counting later.].
virtual | ~Picture ()
| Destructor.
Picture & | operator= (const Picture &rhs)
| Assignment =. Private as not currently used [may want to implement reference counting later.].
void | Fill (ValueType val)
| Picture Fill.
PictureParams & | GetPparams () const
| Gets the picture parameters.
void | SetPictureSort (const PictureSort ps)
| Sets the picture sort.
void | SetPictureType (const PictureType ftype)
| Sets the picture type.
void | SetReferenceType (const ReferenceType rtype)
| Sets the picture type.
void | ReconfigPicture (const PictureParams &pp)
| Reconfigures to the new parameters.
PicArray & | Data (CompSort cs)
| Returns a given component.
const PicArray & | Data (CompSort cs) const
| Returns a given component.
PicArray & | UpData (CompSort cs)
| Returns a given upconverted component.
const PicArray & | UpData (CompSort cs) const
| Returns a given upconverted component.
const CoeffArray & | WltData (CompSort c) const
| Returns the wavelet coefficient data.
CoeffArray & | WltData (CompSort c)
| Returns the wavelet coefficient data.
void | InitWltData (const int transform_depth)
| Initialises the wavelet coefficient data arrays;.
void | Clip ()
| Clip the data to prevent overshoot.
void | ClipUpData ()
| Clip the upconverted data to prevent overshoot.

## Private Member Functions
virtual void | ClearData ()
| Delete all the data.
void | AntiAliasFilter (PicArray &out_data, const PicArray &in_data) const
| Filters a (field) picture vertically to reduce aliasing for motion estimation purposes.
const PicArray & | FiltData (CompSort c) const
| Returns an anti-aliased version of the original data.
const PicArray & | CombinedData () const
const PicArray & | UpCombinedData () const
void | Combine (PicArray &comb_data, const PicArray &y_data, const PicArray &u_data, const PicArray &v_data) const
const PicArray & | UpFiltData (CompSort c) const
| Returns an upconverted anti-aliased version of the original data.
void | SetOrigData (const int c)

## Private Attributes
PicArray * | m_orig_data [3]
PicArray * | m_orig_up_data [3]
PicArray * | m_filt_data [3]
PicArray * | m_filt_up_data [3]
MEData * | m_me_data
unsigned int | m_status
double | m_complexity
double | m_norm_complexity
double | m_pred_bias

## Additional Inherited Members
Protected Member Functions inherited from dirac::Picture
virtual void | Init ()
| Initialises the picture once the picture parameters have been set.
void | ClipComponent (PicArray &pic_data, CompSort cs) const
| Clip an individual component.
Protected Attributes inherited from dirac::Picture
PictureParams | m_pparams
PicArray * | m_pic_data [3]
PicArray * | m_up_pic_data [3]
CoeffArray | m_wlt_data [3]

## Constructor & Destructor Documentation

dirac::EncPicture::EncPicture | ( | const PictureParams & | pp | ) |

virtual dirac::EncPicture::~EncPicture | ( |  | ) |
| virtual

## Member Function Documentation

void dirac::EncPicture::AntiAliasFilter | ( | PicArray & | out_data,
|  | const PicArray & | in_data
| ) |  | const
| private

virtual void dirac::EncPicture::ClearData | ( |  | ) |
| private virtual

Reimplemented from dirac::Picture.

void dirac::EncPicture::Combine | ( | PicArray & | comb_data,
|  | const PicArray & | y_data,
|  | const PicArray & | u_data,
|  | const PicArray & | v_data
| ) |  | const
| private

const PicArray& dirac::EncPicture::CombinedData | ( |  | ) | const
| private

const PicArray& dirac::EncPicture::DataForME | ( | bool | combined_me | ) | const

void dirac::EncPicture::DropRef | ( | int | rindex | ) |

const PicArray& dirac::EncPicture::FiltData | ( | CompSort | c | ) | const
| private

void dirac::EncPicture::FlipStatus | ( | const unsigned int | mask | ) |
| inline

References m_status.

double dirac::EncPicture::GetComplexity | ( |  | ) | const
| inline

References m_complexity.

MEData& dirac::EncPicture::GetMEData | ( |  | ) |
| inline

References m_me_data.

const MEData& dirac::EncPicture::GetMEData | ( |  | ) | const
| inline

References m_me_data.

double dirac::EncPicture::GetNormComplexity | ( |  | ) | const
| inline

References m_norm_complexity.

double dirac::EncPicture::GetPredBias | ( |  | ) | const
| inline

References m_pred_bias.

unsigned int dirac::EncPicture::GetStatus | ( |  | ) | const
| inline

References m_status.

void dirac::EncPicture::InitMEData | ( | const PicturePredParams & | predparams,
|  | const int | num_refs
| ) |  |

const PicArray& dirac::EncPicture::OrigData | ( | CompSort | c | ) | const
| inline

References m_orig_data.

void dirac::EncPicture::SetComplexity | ( | double | c | ) |
| inline

References m_complexity.

void dirac::EncPicture::SetNormComplexity | ( | double | c | ) |
| inline

References m_norm_complexity.

void dirac::EncPicture::SetOrigData | ( |  | ) |

void dirac::EncPicture::SetOrigData | ( | const int | c | ) |
| private

void dirac::EncPicture::SetPredBias | ( | double | b | ) |
| inline

References m_pred_bias.

void dirac::EncPicture::SetStatus | ( | const int | status | ) |
| inline

References m_status.

const PicArray& dirac::EncPicture::UpCombinedData | ( |  | ) | const
| private

const PicArray& dirac::EncPicture::UpDataForME | ( | bool | combined_me | ) | const

void dirac::EncPicture::UpdateStatus | ( | const unsigned int | mask | ) |
| inline

References m_status.

const PicArray& dirac::EncPicture::UpFiltData | ( | CompSort | c | ) | const
| private

const PicArray& dirac::EncPicture::UpOrigData | ( | CompSort | cs | ) | const

## Member Data Documentation

double dirac::EncPicture::m_complexity
| private

Referenced by GetComplexity(), and SetComplexity().

PicArray* dirac::EncPicture::m_filt_data[3]
| mutable private

PicArray* dirac::EncPicture::m_filt_up_data[3]
| mutable private

MEData* dirac::EncPicture::m_me_data
| private

Referenced by GetMEData().

double dirac::EncPicture::m_norm_complexity
| private

Referenced by GetNormComplexity(), and SetNormComplexity().

PicArray* dirac::EncPicture::m_orig_data[3]
| private

Referenced by OrigData().

PicArray* dirac::EncPicture::m_orig_up_data[3]
| mutable private

double dirac::EncPicture::m_pred_bias
| private

Referenced by GetPredBias(), and SetPredBias().

unsigned int dirac::EncPicture::m_status
| private

Referenced by FlipStatus(), GetStatus(), SetStatus(), and UpdateStatus().

The documentation for this class was generated from the following file:

- enc_picture.h

© 2004 British Broadcasting Corporation. Dirac code licensed under the Mozilla Public License (MPL) Version 1.1.
HTML documentation generated by Dimitri van Heesch's excellent Doxygen tool.